//=============================================================================
//=============================================================================

#ifndef _INC_XC_ENGINE
#define _INC_XC_ENGINE


#ifndef __LINUX_X86__
	#define CORE_API DLL_IMPORT
	#define XC_ENGINE_API DLL_EXPORT
	#include <windows.h>
	#include <shlobj.h>
#else
	//If we don't disable this, v436 std (some builds) won't be able to run this mod
	#define DO_GUARD 0
	#include <unistd.h>	
#endif


//Engine includes
#include "Engine.h"
#include "UnNet.h" 
//#include "UnLinker.h" 
#include "UnRender.h"

#ifndef __LINUX_X86__
	#include "..\..\Window\inc\Window.h"
#endif


class UXC_GameEngine;
class FXC_TravelManager;
class FXC_TimeManager;
class FCollisionCacus;
class FNodeGrid3;

//Script
#define debugf GLog->Logf

//Math
#include "UnXC_Math.h"

//Classes here
#include "UnXC_FieldIterator.h"
#include "UnXC_Game.h"		// Game Engine edited
#include "XC_Inlines.h"


#endif
