//Find AdminLogin and rewrite it with our hook as conditional

/*
// This
exec function AdminLogin( string Password )
{
	Level.Game.AdminLogin( Self, Password );
}

// Into
exec function AdminLogin( string Password )
{
	if ( AdminLoginHook( self) )
		Level.Game.AdminLogin( Self, Password );
}
*/


void UXC_GameEngine::ReplaceAdminLoginFunc( UBOOL bSet)
{
	guard(UXC_GameEngine::ReplaceAdminLoginFunc);

	if ( b451Setup || !GetActiveLevel(this)->NetDriver ) //We don't need this here
		return;

	UFunction* AdminLogin = FindBaseFunction( APlayerPawn::StaticClass(), TEXT("AdminLogin"));
	if ( !AdminLogin ) //Script not serialized?
		return;

	GNatives[3551] = ExecUndefined;
	if ( !OldAdminLogin.Num() )
	{
		if ( !bSet )
			return;
		OldAdminLogin = AdminLogin->Script;
	}
	
	if ( !bSet )
	{
		check( OldAdminLogin.Num() );
		AdminLogin->Script = OldAdminLogin;
		debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("Reverting PlayerPawn.AdminLogin hook") );
		return;
	}
	else if ( OldAdminLogin.Num() != AdminLogin->Script.Num() )
		return;

	//Initialize remaining vars
	INT Found = 0;
	UProperty* Password = FindInstanceVariable( AdminLogin, TEXT("Password"), &Found);
	UProperty* Level = FindInstanceVariable( AActor::StaticClass(), TEXT("Level"), &Found);
	UProperty* Game = FindInstanceVariable( ALevelInfo::StaticClass(), TEXT("Game"), &Found);
	check( Found == 3 );

	AdminLogin->Script.Empty();
	AdminLogin->Script.AddZeroed( 39);
	
	BYTE* Block = &AdminLogin->Script( 0);

	JumpToIfNot( Block, 37);				Block += 3; // (3)
	GNatives[3551] = (Native)&AXC_DummyPawn::AdminLoginNative;
	HighNative( Block, 3551);				Block += 2; // (5)
	*Block++ = EX_Self;	// (6)
	*Block++ = EX_EndFunctionParms; // (7)
	*Block++ = EX_Context; // (8)
	_obj_SingleContext( Block, 1, Level);	Block += 9; // (17)
	ParseInstanceVariable( Block, Game);	Block += 5; // (22)
	*Block++ = 0x0C; // (23)
	*Block++ = 0x00; // (24)
	*Block++ = 0x00; // (25)
	*Block++ = EX_VirtualFunction; // (26)
	WriteINT( Block, AdminLogin->GetFName().GetIndex() );	Block += 4; // (30)
	*Block++ = EX_Self;	// (31)
	ParseLocalVariable( Block, Password);	Block += 5; // (36)
	*Block++ = EX_EndFunctionParms; // (37)
	
	AddReturn( Block); // (39)

	debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("PlayerPawn.AdminLogin hook success"));
	unguard;
}
