/*=============================================================================
	Time manager to fix speed issues
=============================================================================*/

#ifndef _INC_XC_TIME
#define _INC_XC_TIME

class FXC_TimeManager : public FExec
{
	public:

	INT SystemDigest[10];
	FLOAT TimeDigest[10];

	INT LastSec;
	INT LastMSec;
	INT MSecAccumulator;
	INT MSecInterval;
	INT IgnoreTimers; //Set at post map change, ignores X timers
	FLOAT Factor;
	FLOAT DeltaAcc;
	
	FXC_TimeManager();
	void Update( UObject* Context, FLOAT DeltaSeconds);

	//FExec interface
	UBOOL Exec( const TCHAR* Cmd, FOutputDevice& Ar );
};

#endif

/*-----------------------------------------------------------------------------
	The End.
-----------------------------------------------------------------------------*/
