//Find PreLogin and check what's at the end of said function


void UXC_GameEngine::ReplacePreLoginFunc( UBOOL bSet)
{
	guard(UXC_GameEngine::ReplacePreLoginFunc);

	UFunction* PreLogin = FindBaseFunction( AGameInfo::StaticClass(), TEXT("PreLogin"));
	if ( !PreLogin ) //Script not serialized?
		return;

	GNatives[3550] = ExecUndefined;
	if ( !OldPreLogin.Num() )
	{
		if ( !bSet )
			return;
		OldPreLogin = PreLogin->Script;
	}
	
	if ( !bSet )
	{
		check( OldPreLogin.Num() );
		PreLogin->Script = OldPreLogin;
		debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("Reverting GameInfo.PreLogin hook") );
		return;
	}
	else if ( OldPreLogin.Num() != PreLogin->Script.Num() )
		return;

	//Initialize remaining vars
	INT Found = 0;
	UProperty* Options = FindInstanceVariable( PreLogin, TEXT("Options"), &Found);
	UProperty* Address = FindInstanceVariable( PreLogin, TEXT("Address"), &Found);
	UProperty* Error = FindInstanceVariable( PreLogin, TEXT("Error"), &Found);
	UProperty* FailCode = FindInstanceVariable( PreLogin, TEXT("FailCode"), &Found);
	check( Found == 4 );
	
	PreLogin->Script.InsertZeroed( PreLogin->Script.Num()-2, 23 ); //Add 23 bytes right before the return
	BYTE* Block = &PreLogin->Script( PreLogin->Script.Num() - 25);

	GNatives[3550] = (Native)&AXC_DummyPawn::PreLoginNative;
	HighNative( Block, 3550);				Block += 2;
	ParseLocalVariable( Block, Options);	Block += 5;
	ParseLocalVariable( Block, Address);	Block += 5;
	ParseLocalVariable( Block, Error);		Block += 5;
	ParseLocalVariable( Block, FailCode);	Block += 5;
	*Block++ = 0x16; //EX_EndFunctionParms
	check( *Block == 0x04); //Beginning of return

	debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("GameInfo.PreLogin hook success"));
	unguard;
}
