//Find showpath and make it only execute if caller is admin or local player


void UXC_GameEngine::ReplaceShowInventoryFunc( UBOOL bSet)
{
	guard(UXC_GameEngine::ReplaceShowInventoryFunc);

	if ( b451Setup ) //Not needed in v451
		return;

	UFunction* ShowInventory = FindBaseFunction( APlayerPawn::StaticClass(), TEXT("ShowInventory"));
	if ( !ShowInventory ) //Script not serialized?
		return;

	if ( !OldShowInventory.Num() )
	{
		if ( !bSet )
			return;
		OldShowInventory = ShowInventory->Script;
	}

	if ( !bSet )
	{
		check( OldShowInventory.Num() );
		ShowInventory->Script = OldShowInventory;
		debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("Reverting PlayerPawn.ShowInventory hook") );
		return;
	}
	else if ( OldShowInventory.Num() != ShowInventory->Script.Num() )
		return;

	//Initialize remaining vars
	INT Found = 0;
	UProperty* bAdmin = FindInstanceVariable( APlayerPawn::StaticClass(), TEXT("bAdmin"), &Found);
	UProperty* Inventory = FindInstanceVariable( AActor::StaticClass(), TEXT("Inventory"), &Found);
	UProperty* Level = FindInstanceVariable( AActor::StaticClass(), TEXT("Level"), &Found);
	UProperty* NetMode = FindInstanceVariable( ALevelInfo::StaticClass(), TEXT("NetMode"), &Found);
	UProperty* SelectedItem = FindInstanceVariable( APawn::StaticClass(), TEXT("SelectedItem"), &Found);
	UProperty* Weapon = FindInstanceVariable( APawn::StaticClass(), TEXT("Weapon"), &Found);
	UProperty* pClass = FindInstanceVariable( UObject::StaticClass(), TEXT("Class"), &Found);
	UProperty* Charge = FindInstanceVariable( AInventory::StaticClass(), TEXT("Charge"), &Found);
//native(231) final static function Log( coerce string S, optional name Tag );
//native(284) final function name GetStateName();
	UProperty* Inv = FindInstanceVariable( ShowInventory, TEXT("Inv"), &Found);
	check( Found == 9 );

	ShowInventory->Script.Empty();
	ShowInventory->Script.AddZeroed( 230);

//	if ( bAdmin || Level.NetMode == NM_Standalone )
//	{
	BYTE* Block = &ShowInventory->Script(0);
	JumpToIfNot( Block, 228);				Block += 3; // (3)
	*Block++ = 0x84; // || (4)
	*Block++ = 0x2D; // EX_BoolVariable (5)
	ParseInstanceVariable( Block, bAdmin);	Block += 5; // (10)
	SkipAhead( Block, 0x15);				Block += 3; // (13)
	*Block++ = 0x9A; // int == int  (14)
	*Block++ = 0x3A; // EX_ByteToInt (15)
	_byte_SingleContext( Block, 1, Level);	Block += 9; // (24)
	ParseInstanceVariable( Block, NetMode);	Block += 5; // (29)
	*Block++ = 0x3A; // EX_ByteToInt (30)
	*Block++ = 0x24; // EX_ByteConst (31) ==== I SHOULD OPTIMIZE THIS SHIT AND DIRECTLY COMPARE TO INT!!!
	*Block++ = 0x00; // 0 constant (32)
	*Block++ = 0x16; // EX_EndFunctionParams (33)
	*Block++ = 0x16; // EX_EndFunctionParams (34)

//		if ( Weapon != None )
	JumpToIfNot( Block, 77);				Block += 3; // (37)
	*Block++ = 0x77; // object != object (38)
	ParseInstanceVariable(Block,Weapon);	Block += 5; // (43)
	*Block++ = 0x2A; // EX_NoObject (44)
	*Block++ = 0x16; // EX_EndFunctionParams (45)

//			Log("   Weapon: " $ string(Weapon.Class));
	*Block++ = 0xE7; // Log (46)
	*Block++ = 0x70; // $ (47)
	Block += StringConstant( Block, "   Weapon: "); // 13 bytes (60)
	*Block++ = 0x56; // EX_ObjectToString (61)
	_obj_SingleContext( Block, 1, Weapon);	Block += 9; // (70)
	ParseInstanceVariable(Block,pClass);		Block += 5; // (75)
	*Block++ = 0x16; // EX_EndFunctionParams (76)
	*Block++ = 0x16; // EX_EndFunctionParams (77)

//		for( Inv=Inventory; Inv!=None; Inv=Inv.Inventory ) 
//			log( "Inv: "$Inv $ " state "$Inv.GetStateName());
	*Block++ = 0x0F; // EX_Let (78)
	ParseLocalVariable(Block,Inv);			Block += 5; // (83)
	ParseInstanceVariable(Block,Inventory);	Block += 5; // (88)
	JumpToIfNot( Block, 165);				Block += 3; // (91)
	*Block++ = 0x77; // obj != obj (92)
	ParseLocalVariable( Block, Inv);		Block += 5; // (97)
	*Block++ = 0x2A; // EX_NoObject (98)
	*Block++ = 0x16; // EX_EndFunctionParams (99)
	*Block++ = 0xE7; // Log (100)
	*Block++ = 0x70; // $ (101)
	*Block++ = 0x70; // $ (102)
	*Block++ = 0x70; // $ (103)
	Block += StringConstant( Block, "Inv: "); // 7 bytes (110)
	*Block++ = 0x56; // EX_ObjectToString (111)
	ParseLocalVariable( Block, Inv);		Block += 5; // (116)
	*Block++ = 0x16; // EX_EndFunctionParams (117)
	Block += StringConstant( Block, " state "); // 9 bytes (126)
	*Block++ = 0x16; // EX_EndFunctionParams (127)
	*Block++ = 0x57; // EX_NameToString (128)
	*Block++ = 0x19; // Context start, we call a high native on Inv (129)
	ParseLocalVariable( Block, Inv);		Block += 5; // (134)
	*Block++ = 0x03;
	*Block++ = 0x00; //Skip 3 bytes (136)
	*Block++ = 0x04; //And clear 4 (name) (137)
	HighNative( Block, 284);				Block += 2; // GetStateName (139)
	*Block++ = 0x16; // EX_EndFunctionParams (140)
	*Block++ = 0x16; // EX_EndFunctionParams (141)
	*Block++ = 0x16; // EX_EndFunctionParams (142)
	*Block++ = 0x0F; // EX_Let (143)
	ParseLocalVariable(Block,Inv);			Block += 5; // (148)
	_obj_SingleContext( Block, 0, Inv);		Block += 9; // (157)
	ParseInstanceVariable(Block,Inventory);	Block += 5; // (162)
	JumpTo( Block, 88);						Block += 3; // (165)

//		if ( SelectedItem != None )
	JumpToIfNot( Block, 228);				Block += 3; // (168)
	*Block++ = 0x77; // obj != obj (169)
	ParseInstanceVariable(Block,SelectedItem);	Block += 5; // (174)
	*Block++ = 0x2A; // EX_NoObject (175)
	*Block++ = 0x16; // EX_EndFunctionParams (176)

//			Log("Selected Item" @ string(SelectedItem) @ "Charge" @ string(SelectedItem.Charge));
	*Block++ = 0xE7; // Log (177)
	*Block++ = 0xA8; // @ (178)
	*Block++ = 0xA8; // @ (179)
	*Block++ = 0xA8; // @ (180)
	Block += StringConstant( Block, "Selected Item"); // 15 bytes (195)
	*Block++ = 0x56; // EX_ObjectToString (196)
	ParseInstanceVariable(Block,SelectedItem);	Block += 5; // (201)
	*Block++ = 0x16; // EX_EndFunctionParams (202)
	Block += StringConstant( Block, "Charge"); // 8 bytes (210)
	*Block++ = 0x16; // EX_EndFunctionParams (211)
	*Block++ = 0x53; // EX_IntToString (212)
	_obj_SingleContext(Block,1,SelectedItem);	Block += 9; // (221)
	ParseInstanceVariable( Block, Charge);	Block += 5; // (226)
	*Block++ = 0x16; // EX_EndFunctionParams (227)
	*Block++ = 0x16; // EX_EndFunctionParams (228)

	AddReturn( Block); // (230)

	debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("PlayerPawn.ShowInventory hook success"));
	unguard;
}
